/*
 * 
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 * 
 */
package org.apache.rat.pd.heuristic.functions;

import junit.framework.TestCase;

public class DelphiFunctionsHeuristicCheckerTest extends TestCase {
    DelphiFunctionHeuristicChecker checker;

    String SIMPLE_FUNCTION_1 = "function name:type;begin end;";
    String SIMPLE_FUNCTION_2 = "Function name  ( pom pom)  : type  ;\n begin end;";
    String SIMPLE_FUNCTION_3 = "function name (pom pom, pom pom, ) : type;\n begin  something;\n something\n  end;";
    String SIMPLE_PROCEDURE_1 = "procedure name; begin end;";
    String SIMPLE_PROCEDURE_2 = "procedure    name   ( pom 1 pom pom  );\n begin\n something\n something  \n end;";

    protected void setUp() throws Exception {
        checker = new DelphiFunctionHeuristicChecker(0, System.out);
    }

    public void testCheckByHeuristic() {
        assertTrue("This is a valid function", checker.checkByHeuristic(SIMPLE_FUNCTION_1).isCheckOnInternetNeaded());
        assertTrue("This is a valid function", checker.checkByHeuristic(SIMPLE_FUNCTION_2).isCheckOnInternetNeaded());
        assertTrue("This is a valid function", checker.checkByHeuristic(SIMPLE_FUNCTION_3).isCheckOnInternetNeaded());
        assertTrue("This is a valid procedure", checker.checkByHeuristic(SIMPLE_PROCEDURE_1).isCheckOnInternetNeaded());
        assertTrue("This is a valid procedure", checker.checkByHeuristic(SIMPLE_PROCEDURE_2).isCheckOnInternetNeaded());

    }
}
